LeetCode 2367. Number of Arithmetic Triplets

给定一个严格递增的整数数组nums和一个正整数diff,目标是找到所有满足条件的长度为3且差值为diff的等差数列三元组(i,j,k)。解决方案是使用哈希集合存储已遍历过的数值,检查当前数值是否能与之前数值形成差分匹配。代码中通过遍历数组并检查set中是否存在num-diff和num-2*diff来找到三元组,然后更新结果计数。

摘要生成于 C知道 ,由 DeepSeek-R1 满血版支持, 前往体验 >

You are given a 0-indexedstrictly increasing integer array nums and a positive integer diff. A triplet (i, j, k) is an arithmetic triplet if the following conditions are met:

  • i < j < k,
  • nums[j] - nums[i] == diff, and
  • nums[k] - nums[j] == diff.

Return the number of unique arithmetic triplets.

Example 1:

Input: nums = [0,1,4,6,7,10], diff = 3
Output: 2
Explanation:
(1, 2, 4) is an arithmetic triplet because both 7 - 4 == 3 and 4 - 1 == 3.
(2, 4, 5) is an arithmetic triplet because both 10 - 7 == 3 and 7 - 4 == 3. 

Example 2:

Input: nums = [4,5,6,7,8,9], diff = 2
Output: 2
Explanation:
(0, 2, 4) is an arithmetic triplet because both 8 - 6 == 2 and 6 - 4 == 2.
(1, 3, 5) is an arithmetic triplet because both 9 - 7 == 2 and 7 - 5 == 2.

Constraints:

  • 3 <= nums.length <= 200
  • 0 <= nums[i] <= 200
  • 1 <= diff <= 50
  • nums is strictly increasing.

就是求长度为3,差为diff的等差数列的个数。刚开始还真没想到怎么做,想复杂了,结果看了答案以后发现用个set存就行了,遍历数组,然后看看之前有没有遇到num - diff和num - 2 * diff,就完事了……我太愚蠢了。

class Solution {
    public int arithmeticTriplets(int[] nums, int diff) {
        Set<Integer> set = new HashSet<>();
        int result = 0;
        for (int num : nums) {
            if (set.contains(num - diff) && set.contains(num - 2 * diff)) {
                result++;
            }
            set.add(num);
        }
        return result;
    }
}

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值